#include "descriptor/descriptor.h"

int main(void) {

  ITEM	glass,ceramic,red,yellow,blu,metal,black,trueblack,grey;

  ITEM  asse,battistrada2,carcassa,disco,frenodisco,pinze,sferacentro,stellacurva1,stellacurva2,stelladritta1,stelladritta2;
  ITEM  specchietto,specchio,attaccospecch;
  ITEM  macch_base,macch_alta,vetrodestro,vetrosinistro,vetroavanti,paraurtiavanti,paraurtidietro,targa_avanti,targa_dietro,fiancatadx,fiancatasx;
  ITEM  alettone,alettonebasedx,alettonebasesx;
  ITEM  lucedietrodx,lucedietrosx,luceavantidx,luceavantisx;
  ITEM  murodietro,murosinistra,murodestra,muroavantipicc,muroavantigrande,saracinesca,soffitto,quadro1,quadro2,quadro3,vetroquadro2,vetroquadro3,tavolo,
        gommatavolo,discotavolo,pinzetavolo,assetavolo;
  ITEM  back1,back2,back3,back4,back5,back6,back7;
  ITEM  gommapila[6];
  ITEM  strada;

  ITEM	teapot_glass,teapot_brown,cup1,cup2;
  ITEM  ruota,ruota_post_destra,ruota_post_sinistra,ruota_ant_sinistra;
  ITEM	scene,retrovisore,retrovisoresx,macchina,ambiente;

  int i=0;

  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "luce esterna 1");
  create_point_light(12,-12,9,1,1,1,4,20, "luce esterna 2");
  create_point_light(4,-4,3.5,1,1,1,3,10, "luce interna");

  /*** ATTRIBUTE glass ***/
  glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,1.2);

  /*** ATTRIBUTE ceramic ***/
  ceramic = create_attribute("ceramic");
  set_color(ceramic,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(ceramic,0.2,128);

  /*** ATTRIBUTE red ***/
  red = create_attribute("red");
  set_color(red,0.7,0,0,0.2,0.8);
  set_reflectivity(red,0.17,15);

  /*** ATTRIBUTE black ***/
  black = create_attribute("black");
  set_color(black,0,0,0,0.2,0.8);
  set_reflectivity(black,0.17,15);

  /*** ATTRIBUTE trueblack ***/
  trueblack = create_attribute("trueblack");
  set_color(trueblack,0,0,0,0,1);
  set_reflectivity(trueblack,0,15);

  /*** ATTRIBUTE yellow ***/
  yellow = create_attribute("yellow");
  set_color(yellow,0.8,0.67,0,0.05,0.8);
  set_reflectivity(yellow,0.05,10);

  /*** ATTRIBUTE blu ***/
  blu = create_attribute("blu");
  set_color(blu,0,0,1,0.5,0.5);
  set_reflectivity(blu,0.3,10);

  /*** ATTRIBUTE metal ***/
  metal = create_attribute("metal");
  set_color(metal,0.625,0.625,0.625,0.11,1.0);   // ambient & diffuse
  set_reflectivity(metal,1.0,15);   // specular & phong's exponent

  /*** ATTRIBUTE grey ***/
  grey = create_attribute("grey");
  set_color(grey,0.5,0.5,0.5,0.5,0.5);
  set_reflectivity(grey,0,10);











//    RUOTA 




  asse = read_nurbs("asse.db");
  set_attribute(asse, metal);
  battistrada2 = read_nurbs("battistrada.db");
  set_domain_texture(battistrada2,trueblack,"texture/tyre.hr",0,1,0,1,0,0,1); 
  carcassa = read_nurbs("carcassa.db"); 
  set_attribute(carcassa, metal);
  disco = read_nurbs("sfondo.db"); 
  set_attribute(disco, trueblack);

  frenodisco = read_nurbs("frenodisco.db");
//  set_translate(frenodisco,20000,0,20000);
//  set_scale(frenodisco,10,10,10);
//  set_projection_texture(frenodisco,trueblack,"frenodisco.hr",1,1,1,1);
  set_domain_texture(frenodisco,trueblack,"texture/frenodisco.hr",0,1,0,1,1,0.5,0.5); 
//  set_scale(frenodisco,(float)1/10,(float)1/10,(float)1/10);
//  set_translate(frenodisco,-20000,0,-20000);
 
  pinze = read_nurbs("pinze.db"); 
  set_attribute(pinze, yellow);


  sferacentro = read_nurbs("sferacentro.db"); 
//  set_attribute(sferacentro, metal);
  set_scale(sferacentro,20,1,20);
  set_translate(sferacentro,0.02,0,-1.5);
  set_projection_texture(sferacentro,metal,"texture/logoblack.hr",1,1,1,1);
  set_translate(sferacentro,-0.02,0,1.5);
  set_scale(sferacentro,(float) 1/20,1,(float) 1/20);

  stellacurva1 = read_nurbs("stellacurva1.db");
  set_attribute(stellacurva1, metal); 
  stellacurva2 = read_nurbs("stellacurva2.db");
  set_attribute(stellacurva2, metal); 
  stelladritta1 = read_nurbs("stelladritta1.db");
  set_attribute(stelladritta1, metal); 
  stelladritta2 = read_nurbs("stelladritta2.db"); 
  set_attribute(stelladritta2, metal); 




//    MACCHINA 





  macch_base = read_nurbs("base.db");
  set_scale(macch_base,(float) 1/1.7,1.2,1);
  set_translate(macch_base,-0.35,-1.05,0);
  set_projection_texture(macch_base,yellow,"texture/carpics.hr",2,0,0.5,0.5);
  set_translate(macch_base,0.35,1.05,0);
  set_scale(macch_base,1.7,(float) 1/1.2,1);


  macch_alta = read_nurbs("alto.db");
  set_attribute(macch_alta, yellow);
  vetrodestro = read_nurbs("vetrodestr.db");
  set_attribute(vetrodestro, black);
  vetroavanti = read_nurbs("vetroavant.db");
//  set_scale(vetroavanti,10,10,1);
  set_translate(vetroavanti,0.6,-0.98,0);
  set_projection_texture(vetroavanti,black,"texture/tetto.hr",2,0,0.5,0.5);
  set_translate(vetroavanti,-0.6,0.98,0);
//  set_scale(vetroavanti,0.1,0.1,1);
//  set_attribute(vetroavanti, black);

  paraurtiavanti = read_nurbs("paraurtiant.db");
  set_attribute(paraurtiavanti, yellow);
  paraurtidietro = read_nurbs("paraurtipost.db");
  set_attribute(paraurtidietro, yellow);

  fiancatadx = read_nurbs("fiancata.db");
  fiancatasx = create_copy(fiancatadx,"fiancatasx");
  set_scale(fiancatadx,0.5,1,2);
  set_translate(fiancatadx,0,0,-0.4);
  set_projection_texture(fiancatadx,yellow,"texture/fiancata.hr",1,1,0.5,0.5);
  set_translate(fiancatadx,0,0,0.4);
  set_scale(fiancatadx,2,1,(float) 1/2);


  set_scale(fiancatasx,0.5,1,2);
  set_translate(fiancatasx,0,0,-0.4);
  set_projection_texture(fiancatasx,yellow,"texture/fiancata2.hr",1,1,0.5,0.5);
  set_translate(fiancatasx,0,0,0.4);
  set_scale(fiancatasx,2,1,(float) 1/2);

  set_scale(fiancatasx,1,-1,1);
  set_translate(fiancatasx,0,1.67,0);

  

  targa_avanti = read_nurbs("targaant.db");
  set_domain_texture(targa_avanti,trueblack,"texture/targaavanti.hr",0,1,0,1,0,0.5,0.5); 
  targa_dietro = read_nurbs("targapost.db");
  set_domain_texture(targa_dietro,trueblack,"texture/nomelamb.hr",0,1,0,1,0,0.5,0.5); 


  back2 = read_nurbs("New4.db");
  set_domain_texture(back2,trueblack,"texture/backgrid.hr",0,0.5,0,0.5,1,0.5,0.5);

  back3 = read_nurbs("New6.db");
  set_domain_texture(back3,trueblack,"texture/backgrid.hr",0,0.2,0,0.2,1,0.5,0.5);

  back4 = read_nurbs("New7.db");
  set_domain_texture(back4,trueblack,"texture/backgrid.hr",0,0.5,0,0.5,1,0.5,0.5);

  back5 = read_nurbs("New8.db");
  set_domain_texture(back5,trueblack,"texture/backgrid.hr",0,0.5,0,0.5,1,0.5,0.5);

  back6 = read_nurbs("New9.db");
  back7 = read_nurbs("New10.db");


  alettone = read_nurbs("alettone.db");
  set_attribute(alettone, yellow);
  alettonebasedx = read_nurbs("alettbasedx.db");
  set_attribute(alettonebasedx, yellow);
  alettonebasesx = read_nurbs("alettbasesx.db");
  set_attribute(alettonebasesx, yellow);


  lucedietrodx = read_nurbs("lucedietrodx.db");
  set_attribute(lucedietrodx, red);
  luceavantidx = read_nurbs("luceavantidx.db");
  set_attribute(luceavantidx, black);




  specchietto = read_nurbs("specchiettosurf.db");
  set_attribute(specchietto, yellow);
  specchio = read_nurbs("specchiosurf.db");
  set_attribute(specchio, metal);
  attaccospecch = read_nurbs("attacchsuperf.db");
  set_attribute(attaccospecch, yellow);




// AMBIENTE



  strada = read_nurbs("strada.db");
  set_projection_texture(strada,trueblack,"texture/asfalto.hr",2,1,1,1);

  murodietro = read_nurbs("paretedietro.db");
  set_translate(murodietro,0,25,0);
  set_projection_texture(murodietro,grey,"texture/walls.hr",0,1,1,1);
  set_translate(murodietro,0,-25,0);

  murosinistra = read_nurbs("paretesinistra.db");
  set_y_rotate(murosinistra,90,1);
  set_projection_texture(murosinistra,grey,"texture/walls.hr",1,1,1,1);
  set_y_rotate(murosinistra,-90,1);

  murodestra = read_nurbs("paretedestra.db");
  set_y_rotate(murodestra,90,1);
  set_projection_texture(murodestra,grey,"texture/walls.hr",1,1,1,1);
  set_y_rotate(murodestra,-90,1);

  muroavantipicc = read_nurbs("muroavantsopr.db");
  set_projection_texture(muroavantipicc,grey,"texture/walls.hr",0,1,1,1);

  muroavantigrande = read_nurbs("pareteavantigrande.db");
  set_projection_texture(muroavantigrande,grey,"texture/walls.hr",0,1,1,1);

  saracinesca = read_nurbs("serranda.db");
  set_x_rotate(saracinesca,90,1);
  set_scale(saracinesca,1,1,0.1);
  set_projection_texture(saracinesca,trueblack,"texture/saracinesca.hr",0,1,1,1);
  set_scale(saracinesca,1,1,10);
  set_x_rotate(saracinesca,-90,1);

  soffitto = read_nurbs("soffitto.db");
  set_projection_texture(soffitto,grey,"texture/walls.hr",2,1,1,1);

  quadro1 = read_nurbs("quadro1.db");
  set_domain_texture(quadro1,trueblack,"texture/blueprints2.hr",0,1,0,1,0,0.5,0.5);

  quadro2 = read_nurbs("quadro2.db");
  set_domain_texture(quadro2,trueblack,"texture/fotolamb2.hr",0,1,0,1,0,0.5,0.5);

  quadro3 = read_nurbs("quadro3.db");
  set_domain_texture(quadro3,trueblack,"texture/lamboq.hr",0,1,0,1,0,0.5,0.5);

  vetroquadro2 = read_nurbs("vetroq2.db");
  set_attribute(vetroquadro2, glass);  

  vetroquadro3 = read_nurbs("vetroq3.db");
  set_attribute(vetroquadro3, glass);  

  tavolo = read_nurbs("tavolo.db");
  set_scale(tavolo,2,1,5);
  set_projection_texture(tavolo,trueblack,"texture/wood.hr",1,1,1,1);
  set_scale(tavolo,(float) 1/2, 1, (float) 1/5);


  gommatavolo = read_nurbs("gommatavolo.db");
  set_domain_texture(gommatavolo,trueblack,"texture/tyre.hr",0,1,0,1,0,0,1);

  discotavolo = read_nurbs("discotavolo.db");
  set_domain_texture(discotavolo,trueblack,"texture/frenodisco.hr",0,1,0,1,1,0.5,0.5);

  pinzetavolo = read_nurbs("pinzatavolo.db");
  set_attribute(pinzetavolo, yellow);

  assetavolo = read_nurbs("assetavolo.db");
  set_attribute(assetavolo, metal);

  gommapila[0] = read_nurbs("gommapila.db");
  set_domain_texture(gommapila[0],trueblack,"texture/tyre.hr",0,1,0,1,0,0,1);

  for(i=1;i<6;i++){

	gommapila[i] = create_copy(gommapila[i-1],"gommapila");
	set_translate(gommapila[i],0,0,0.4);

}





  ruota = create_list(asse, "gomma");
  ruota = insert_in_list(ruota,battistrada2);
  ruota = insert_in_list(ruota,carcassa);
  ruota = insert_in_list(ruota,disco);
  ruota = insert_in_list(ruota,frenodisco);
  ruota = insert_in_list(ruota,pinze);
  ruota = insert_in_list(ruota,sferacentro);
  ruota = insert_in_list(ruota,stellacurva1);
  ruota = insert_in_list(ruota,stellacurva2);
  ruota = insert_in_list(ruota,stelladritta1);
  ruota = insert_in_list(ruota,stelladritta2);



  ruota_post_destra = create_copy(ruota,"ruota_post_destra");
  set_translate(ruota_post_destra,-2,0,0);


  ruota_post_sinistra = create_copy(ruota,"ruota_post_sinistra");
  set_scale(ruota_post_sinistra,1,-1,1);
  set_translate(ruota_post_sinistra,-2,1.67,0);


  ruota_ant_sinistra = create_copy(ruota,"ruota_ant_sinistra");
  set_scale(ruota_ant_sinistra,1,-1,1);
  set_translate(ruota_ant_sinistra,0,1.67,0);





  retrovisore = create_list(specchietto, "specchietto");
  retrovisore = insert_in_list(retrovisore,specchio);
  retrovisore = insert_in_list(retrovisore,attaccospecch);


  retrovisoresx = create_copy(retrovisore,"retrovisore_sinistro");
  set_scale(retrovisoresx,1,-1,1);
  set_translate(retrovisoresx,0,1.67,0);



  macchina = create_list(macch_base, "car");
  macchina = insert_in_list(macchina,macch_alta);
  macchina = insert_in_list(macchina,vetrodestro);

  vetrosinistro = create_copy(vetrodestro,"vetrosinistro");
  set_scale(vetrosinistro,1,-1,1);
  set_translate(vetrosinistro,0,1.65,0);

  macchina = insert_in_list(macchina,vetrosinistro);
  macchina = insert_in_list(macchina,vetroavanti);


 

  macchina = insert_in_list(macchina,paraurtiavanti);
  macchina = insert_in_list(macchina,paraurtidietro);
  macchina = insert_in_list(macchina,targa_avanti);
  macchina = insert_in_list(macchina,targa_dietro);



  back1 = create_copy(back2,"back1");
  set_scale(back1,1,-1,1);
  set_translate(back1,0,1.66,0);

  macchina = insert_in_list(macchina,back1);
  macchina = insert_in_list(macchina,back2);
  macchina = insert_in_list(macchina,back3);
  macchina = insert_in_list(macchina,back4);
  macchina = insert_in_list(macchina,back5);
  macchina = insert_in_list(macchina,back6);
  macchina = insert_in_list(macchina,back7);

  macchina = insert_in_list(macchina,fiancatadx);



  macchina = insert_in_list(macchina,fiancatasx);


  macchina = insert_in_list(macchina,alettone);
  macchina = insert_in_list(macchina,alettonebasedx);
  macchina = insert_in_list(macchina,alettonebasesx);


  macchina = insert_in_list(macchina,lucedietrodx);

  lucedietrosx = create_copy(lucedietrodx,"lucedietrosx");
  set_scale(lucedietrosx,1,-1,1);
  set_translate(lucedietrosx,0,1.66,0);


  macchina = insert_in_list(macchina,lucedietrosx);


  macchina = insert_in_list(macchina,luceavantidx);

  luceavantisx = create_copy(luceavantidx,"luceavantisx");
  set_scale(luceavantisx,1,-1,1);
  set_translate(luceavantisx,0,1.66,0);


  macchina = insert_in_list(macchina,luceavantisx);


  ambiente = create_list(strada, "ambiente");

  ambiente = insert_in_list(ambiente,murodietro);
  ambiente = insert_in_list(ambiente,murosinistra);
  ambiente = insert_in_list(ambiente,murodestra);
  ambiente = insert_in_list(ambiente,muroavantipicc);
  ambiente = insert_in_list(ambiente,muroavantigrande);
  ambiente = insert_in_list(ambiente,saracinesca);
  ambiente = insert_in_list(ambiente,soffitto);
  ambiente = insert_in_list(ambiente,quadro1);
  ambiente = insert_in_list(ambiente,quadro2);
  ambiente = insert_in_list(ambiente,quadro3);
  ambiente = insert_in_list(ambiente,vetroquadro2);
  ambiente = insert_in_list(ambiente,vetroquadro3);
  ambiente = insert_in_list(ambiente,tavolo);
  ambiente = insert_in_list(ambiente,gommatavolo);
  ambiente = insert_in_list(ambiente,discotavolo);
  ambiente = insert_in_list(ambiente,pinzetavolo);
  ambiente = insert_in_list(ambiente,assetavolo);


  for(i=0;i<6;i++) ambiente = insert_in_list(ambiente,gommapila[i]);



  scene = create_list(macchina, "scene");


  scene = insert_in_list(scene,ruota);
  scene = insert_in_list(scene,ruota_post_destra);
  scene = insert_in_list(scene,ruota_post_sinistra);
  scene = insert_in_list(scene,ruota_ant_sinistra);
  scene = insert_in_list(scene,retrovisore);
  scene = insert_in_list(scene,retrovisoresx);
  scene = insert_in_list(scene,ambiente);

  
int j;
for (j=0; j<=30; j++)
{    
       save_scene_ani(30,"lamborghini.ani","lamborghini","scena_lamborghini", scene);
}
  return(0);
}

